/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// JumpTrigger the model 'JumpTrigger'
type JumpTrigger string

// List of JumpTrigger
const (
	JumpTriggerMessageReceived JumpTrigger = "message_received"
	JumpTriggerWaitReached JumpTrigger = "wait_reached"
	JumpTriggerExternalEvent JumpTrigger = "external_event"
	JumpTriggerButton JumpTrigger = "button"
	JumpTriggerSuccess JumpTrigger = "success"
)

// All allowed values of JumpTrigger enum
var AllowedJumpTriggerEnumValues = []JumpTrigger{
	"message_received",
	"wait_reached",
	"external_event",
	"button",
	"success",
}

func (v *JumpTrigger) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := JumpTrigger(value)
	for _, existing := range AllowedJumpTriggerEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid JumpTrigger", value)
}

// NewJumpTriggerFromValue returns a pointer to a valid JumpTrigger
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewJumpTriggerFromValue(v string) (*JumpTrigger, error) {
	ev := JumpTrigger(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for JumpTrigger: valid values are %v", v, AllowedJumpTriggerEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v JumpTrigger) IsValid() bool {
	for _, existing := range AllowedJumpTriggerEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to JumpTrigger value
func (v JumpTrigger) Ptr() *JumpTrigger {
	return &v
}

type NullableJumpTrigger struct {
	value *JumpTrigger
	isSet bool
}

func (v NullableJumpTrigger) Get() *JumpTrigger {
	return v.value
}

func (v *NullableJumpTrigger) Set(val *JumpTrigger) {
	v.value = val
	v.isSet = true
}

func (v NullableJumpTrigger) IsSet() bool {
	return v.isSet
}

func (v *NullableJumpTrigger) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJumpTrigger(val *JumpTrigger) *NullableJumpTrigger {
	return &NullableJumpTrigger{value: val, isSet: true}
}

func (v NullableJumpTrigger) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJumpTrigger) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

